#include <bits/stdc++.h>
struct point{
    int x, y;
    bool operator<(point other) const {
        if (x < other.x)
            return true;
        if (x > other.x)
            return false;
        return y < other.y;
    }
    point operator-(point other){
        return point{x-other.x, y-other.y};
    }
    double length(){
        return std::sqrt((long long)x*x+(long long)y*y);
    }
};
struct event {
    enum axis{
        X = 0,
        Y = 1
    };
    bool operator<(event other) const{
        return when < other.when;
    }
    double when;
    axis ax;
    bool to_negative;
};
//x' = cos*x - sin*y
//y' = sin*x + cos*y
//sum x' + y' =
//(sin+cos)*X + (cos-sin)*Y
//
//sum |x'| + |y'| =
//(cos+sin)
event x_change(point f, point s){
    s = s - f;
    // угол < 180 => sin >= 0
    // cos*x - sin*y == 0
    // t = sin
    // sqrt(1-t^2)x - t*y == 0
    // tt*yy = (1-tt)*xx
    // tt*yy = xx - ttxx
    // tt*(yy+xx) = xx
    // t = sqrt(xx/(yy+xx))
    event result;
    result.ax = event::X;
    result.when = s.x/s.length();
    result.to_negative = s.x > 0;
    return result;

}
event y_change(point f, point s){
    s = s - f;
    // угол < 180 => sin >= 0
    // sin*x + cos*y == 0
    // t = sin
    // tx + sqrt(1-t^2)*y == 0
    // tt*xx = (1-tt)*yy
    // tt*xx = yy - ttyy
    // tt*(yy+xx) = yy
    // t = sqrt(yy/(yy+xx))
    event result;
    result.ax = event::Y;
    result.when = s.y/s.length();
    result.to_negative = s.y > 0;
    return result;
    
}
double length(point diff, double c, double s){
    return std::abs(diff.x*c - diff.y*s) + std::abs(diff.x*s + diff.y*c);
}
int main(){
    int n;
    std::cin >> n;
    std::vector<point> points(n);
    for (auto& [x, y] : points){
        std::cin >> x >> y;
    }
    int iter_count = 1;
    for (int i = 1; i <= n; i++)
    {
        iter_count *= i;
    }
    double result = INFINITY;
    for (int i = 0; i < iter_count; i++)
    {

        std::next_permutation(points.begin(), points.end());
        for (int j = 1; j < n; j++)
        {
            double local_result = 0;
            point main_diff = points[j] - points[j-1];
            double s = -main_diff.y/main_diff.length();
            double c = main_diff.x/main_diff.length();
            if (s < 0){
                s = -s;
                c = -c;
            }
            for (int k = 1; k < n; k++)
            {
                point diff = points[k] - points[k-1];
                local_result += length(diff, c, s);
            }
            result = std::min(result, local_result);
        }
        
    }
    std::cout << std::fixed << std::setprecision(10);
    std::cout << result << '\n';
    
}