#include <bits/stdc++.h>
struct point{
    int x, y;
    bool operator<(point other) const {
        if (x < other.x)
            return true;
        if (x > other.x)
            return false;
        return y < other.y;
    }
    point operator-(point other){
        return point{x-other.x, y-other.y};
    }
    double length(){
        return std::sqrt((long long)x*x+(long long)y*y);
    }
};
struct event {
    enum axis{
        X = 0,
        Y = 1
    };
    bool operator<(event other) const{
        return when < other.when;
    }
    long long
        dsinX,
        dsinY,
        dcosX,
        dcosY;
    double when;
};
const double pi = asin(1)*2;
//x' = cos*x - sin*y
//y' = sin*x + cos*y
//sum x' + y' =
//cosX - sinY + sinX - cosY
//
//sum |x'| + |y'| =
//(cos+sin)
double lengthX(point diff, double c, double s){
    return std::abs(diff.x*c - diff.y*s);
}
double lengthY(point diff, double c, double s){
    return std::abs(diff.x*s + diff.y*c);
}
double length(point diff, double c, double s){
    return std::abs(diff.x*c - diff.y*s) + std::abs(diff.x*s + diff.y*c);
}
event x_change(point diff){
    // угол < 180 => sin >= 0
    // x' = cos*x - sin*y == 0
    event result;
    if (diff.y <= 0){
        diff.x = -diff.x;
        diff.y = -diff.y;
    }
    result.when = 0;
    if (diff.x != 0)
        result.when = std::fmod(2.5*pi-std::atan2(diff.y, diff.x), pi);
    if (diff.x <= 0){
        diff.x = -diff.x;
        diff.y = -diff.y;
    }
    result.dcosY = 0;
    result.dsinX = 0;
    result.dcosX = -diff.x*2;
    result.dsinY = diff.y*2;
    return result;

}
event y_change(point diff){
    // угол < 180 => sin >= 0
    // y' = sin*x + cos*y == 0
    // t = sin
    // tx + sqrt(1-t^2)*y == 0
    // tt*xx = (1-tt)*yy
    // tt*xx = yy - ttyy
    // tt*(yy+xx) = yy
    // t = sqrt(yy/(yy+xx))
    event result;
    if (diff.y <= 0)
    {
        diff.x = -diff.x;
        diff.y = -diff.y;
    }
    result.when = 0;
    if (diff.y != 0)
        result.when = std::fmod(3*pi-std::atan2(diff.y, diff.x), pi);
    result.dcosX = 0;
    result.dsinY = 0;
    result.dsinX = -diff.x*2;
    result.dcosY = -diff.y*2;
    return result;
    
}
int main(){
    int n;
    std::cin >> n;
    std::vector<point> points(n);
    for (auto& [x, y] : points){
        std::cin >> x >> y;
    }
    int iter_count = 1;
    for (int i = 1; i <= n; i++)
    {
        iter_count *= i;
    }
    double result = INFINITY;
    for (int i = 0; i < iter_count; i++)
    {

        std::next_permutation(points.begin(), points.end());
        std::vector<event> events;
        std::vector<std::pair<double, std::pair<double, double>>> angles;
        long long cos_mul_X = 0;
        long long sin_mul_X = 0;
        long long cos_mul_Y = 0;
        long long sin_mul_Y = 0;
        for (int j = 1; j < n; j++)
        {
            point diff = points[j] - points[j-1];
            auto xevent = x_change(diff);
            events.push_back(xevent);
            auto yevent = y_change(diff);
            events.push_back(yevent);
            sin_mul_X -= xevent.dsinX + yevent.dsinX;
            sin_mul_Y -= xevent.dsinY + yevent.dsinY;
            cos_mul_X -= xevent.dcosX + yevent.dcosX;
            cos_mul_Y -= xevent.dcosY + yevent.dcosY;
        }
        sin_mul_X /= 2;
        sin_mul_Y /= 2;
        cos_mul_X /= 2;
        cos_mul_Y /= 2;
        std::sort(events.begin(), events.end());
        for (int j = 1; j < n; j++)
        {
            point main_diff = points[j] - points[j-1];
            double s = -main_diff.y/main_diff.length();
            double c = main_diff.x/main_diff.length();
            if (s < 0){
                s = -s;
                c = -c;
            }
            angles.emplace_back(fmod(2*pi+atan2(s, c), pi), std::pair<double, double>{s, c});
        }
        std::sort(angles.begin(), angles.end());
        int events_passed = 0;
        for (auto [a, info] : angles)
        {
            auto [s, c] = info;
            if(events_passed != events.size())
                while(events[events_passed].when <= a){
                    event curevent = events[events_passed];
                    sin_mul_X += curevent.dsinX;
                    sin_mul_Y += curevent.dsinY;
                    cos_mul_X += curevent.dcosX;
                    cos_mul_Y += curevent.dcosY;
                    events_passed++;
                    if (events_passed == events.size())
                        break;
                }
            double local_result = s*(sin_mul_X+sin_mul_Y) + c*(cos_mul_X+cos_mul_Y);
            result = std::min(result, std::abs(local_result));
        }
        
        
        
    }
    std::cout << std::fixed << std::setprecision(10);
    std::cout << result << '\n';
    
}